#include "nTupleReader.h"

using namespace std;

int main(){

	std::vector<std::string> fs;
	fs.push_back("/home/daniel/workspace/NtupleAnalysis/build_fedora/install_dir/share/ntuplereader/sample.root");

	nTupleReader r;


	r.setPDF("cteq6ll.LHpdf");
	r.addFiles(fs);

	while(r.nextEntry()){
		int id=r.getID();
		cout << "Checking momentum conservation for event ID: " 
				<< id << std::endl;
		double sumX=0;
		double sumY=0;
		double sumZ=0;
		int nbrP=r.getParticleNumber();
		std::cout << "Number of particles: " 
                          << nbrP << std::endl;
		for (int i=0;i<nbrP;i++){
			sumX+=r.getX(i);
			sumY+=r.getY(i);
			sumZ+=r.getZ(i);
		}
		std::cout << "Sum X: " << sumX << std::endl;
		std::cout << "Sum Y: " << sumY << std::endl;
		std::cout << "Sum Z: " << sumZ 
				<< " to be compared with: " 
				<<  3500 * ( r.getX1()-r.getX2())<<  std::endl;
	}

	return 0;

}
