#include "pdf.h"
#include "LHAPDF/LHAPDF.h"
#include <iostream>

using namespace std;

namespace Pdf {

int initialState::s_id1=1;
int initialState::s_id2=1;

void initialState::setInitialState(int id1,int id2){
	initialState::s_id1=id1;
	initialState::s_id2=id2;
};


// works for u,d,s,c,b,t,g
double pdf(double x, double Q, int PDGcode,int initialState){
	double results[13];
	LHAPDF::xfx(x,Q,results);
//	if (Q>1e4){ throw;}
	if ( initialState == 1 ){
		return results[6+(PDGcode%21)]/x;
	} else {
		return results[6-(PDGcode%21)]/x;
	}
}

double pdf_vsub1(double x, double Q, int PDGcode,int initialState){
	double results[13];
	LHAPDF::xfx(x,Q,results);
/*	cout << " PDF: " << results[0] << " ";
	cout << results[1] << " ";
	cout << results[2] << " ";
	cout << results[3] << " ";
	cout << results[4] << " ";
	cout << results[5] << " ";
	cout << results[6] << " ";
	cout << results[7] << " ";
	cout << results[8] << " ";
	cout << results[9] << " ";
	cout << results[10] << " ";
	cout << results[11] << " ";
	cout << results[12] << " " <<endl;*/
if (PDGcode == GLUON){
		return (results[0]+results[1]+results[2]+results[3]+results[4]+results[5]+results[7]+results[8]+results[9]+results[10]+results[11]+results[12])/x;
	} else {
		if ( initialState == 1 ){
			return results[6+(PDGcode%21)]/x;
		} else {
			return results[6-(PDGcode%21)]/x;
		}
	}
}

double pdf_vsub2(double x,double xp, double Q, int PDGcode,int initialState){
	double results[13];
	LHAPDF::xfx(x/xp,Q,results);
	if (PDGcode == GLUON){
		double allQuarks=results[0]+results[1]+results[2]+results[3]+results[4]+results[5]+results[7]+results[8]+results[9]+results[10]+results[11]+results[12];
		return (allQuarks)/x;
	} else {
		if ( initialState == 1 ){
			return results[6+(PDGcode%21)]/x;
		} else {
			return results[6-(PDGcode%21)]/x;
		}
	}
}

double pdf_vsub3(double x, double Q, int PDGcode,int initialState){
	return pdf(x,Q,GLUON,initialState);
}

double pdf_vsub4(double x,double xp, double Q, int PDGcode,int initialState){
	return pdf(x/xp,Q,GLUON,initialState)/xp;
}

void LHAComputePdf(double x,double Q,pdfArray& pa){
	LHAPDF::xfx(x,Q,&pa.tbar);
	pa.x=x;
	pa.u/=x;
	pa.ubar/=x;
	pa.d/=x;
	pa.dbar/=x;
	pa.s/=x;
	pa.sbar/=x;
	pa.c/=x;
	pa.cbar/=x;
	pa.b/=x;
	pa.bbar/=x;
	pa.t/=x;
	pa.tbar/=x;
	pa.gluon/=x;
}

double pdf(const pdfArray& X, int PDGcode,int initialState){
	if (initialState == 1){
		return X[6+(PDGcode%21)];
	} else {
		return X[6-(PDGcode%21)];
	}
};


double pdf_vsub1(const pdfArray& X, int PDGcode,int initialState){
if (PDGcode == GLUON){
		return (X.t+X.b+X.c+X.s+X.d+X.u+X.ubar+X.dbar+X.sbar+X.cbar+X.bbar+X.tbar);
	} else {
		if (initialState == 1){
			return X[6+(PDGcode%21)];
		}
		else {
			return X[6-(PDGcode%21)];
		}
	}
}

double pdf_vsub2(const pdfArray& XoverXp, double xp, int PDGcode,int initialState){
	if (PDGcode == GLUON){
		double allQuarks=(XoverXp.t+XoverXp.b+XoverXp.c+XoverXp.s+XoverXp.d+XoverXp.u+XoverXp.ubar+XoverXp.dbar+XoverXp.sbar+XoverXp.cbar+XoverXp.bbar+XoverXp.tbar);
		return allQuarks/xp;
	} else {
		if (initialState == 1){
			return XoverXp[6+(PDGcode%21)]/xp;
		}
		else {
			return XoverXp[6-(PDGcode%21)]/xp;
		}
	}
}

double pdf_vsub3(const pdfArray& X, int PDGcode,int initialState){
	return X.gluon;
}

double pdf_vsub4(const pdfArray& XoverXp, double xp, int PDGcode,int initialState){
	return XoverXp.gluon/xp;
}



} /* Pdf */
