#ifndef _H_PDF_H
#define _H_PDF_H


namespace Pdf {

struct initialState {
	static int s_id1;
	static int s_id2;
	static void setInitialState(int id1,int id2);
} ;


// works for u,d,s,c,b,t,g
double pdf(double x, double Q, int PDGcode,int initialState);

double pdf_vsub1(double x, double Q, int PDGcode,int initialState);
double pdf_vsub2(double x, double xp, double Q, int PDGcode,int initialState);
double pdf_vsub3(double x, double Q, int PDGcode,int initialState);
double pdf_vsub4(double x, double xp, double Q, int PDGcode,int initialState);

enum pdgCodes { GLUON=21  };

struct pdfArray {
		double tbar;
		double bbar;
		double cbar;
		double sbar;
		double ubar;
		double dbar;
		double gluon;
		double d;
		double u;
		double s;
		double c;
		double b;
		double t;
		double x;
		double operator[](int n) const {return *(&tbar+n);};
};

double pdf(const pdfArray& X, int PDGcode,int initialState);


double pdf_vsub1(const pdfArray& X, int PDGcode,int initialState);
double pdf_vsub2(const pdfArray& XoverXp, double x, int PDGcode,int initialState);
double pdf_vsub3(const pdfArray& X, int PDGcode,int initialState);
double pdf_vsub4(const pdfArray& XoverXp, double xp, int PDGcode,int initialState);


void LHAComputePdf(double x,double Q,pdfArray& pa);


} /* Pdf */

#endif /* _H_PDF_H */
