/*
 * weightFunctions.h
 *
 *  Created on: Jan 13, 2012
 *      Author: daniel
 */

#ifndef WEIGHTFUNCTIONS_H_
#define WEIGHTFUNCTIONS_H_

#include "NtupleInfo.h"

double computePDFFactor(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newScale);

double computeBornWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double alphaFactor);
double computeBornWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double newRenScale,int alphasPower);

double computeLoopWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double newRenScale,int alphasPower);
double computeLoopWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double newRenScale,double alphaFactor);

double computeVsubWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double newRenScale,int alphasPower);
double computeVsubWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double newRenScale,double alphaFactor);

double computeRealWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double newRenScale,int alphasPower);
double computeRealWeight(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double alphaFactor);

double computeRealWeightWithProperStat(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double alphaFactor);
double computeRealWeightWithProperStat(NtupleInfo<MAX_NBR_PARTICLES>& Ev,double newFacScale,double newRenScale,int alphasPower);

#endif /* WEIGHTFUNCTIONS_H_ */
